// Version information
var app = 'GoT Tracker';             // application title
var ver = '2.72';                    // version
var pch = '';                        // patch level
var lan = 'en';                      // default language
var version = app+' v'+ver+pch;      // Full application title
var rts = 1091909342;                // release timestamp

var versionURL = 'http://www.xs4all.nl/~crisp/gottracker/version.js';
var websiteURL = 'http://www.xs4all.nl/~crisp/gottracker/';
var mainwin = 0;

var popupSize = {
  tracker: [224,451,224,450],
  followtopics: [198,536,400,536],
  forums: [391,566,540,566],
  prefs: [362,385,460,385],
  help: [405,606,440,606],
  calendar: [120,186,280,186],
  addtopic: [158,426,300,426],
  forumupdate: [161,390,400,390],
  colorpick: [192,192,192,192]
}

// re-set opener link to window
try {
  if (opener) {
    if (opener.popups && opener.popups[window.name]) opener.popups[window.name] = self;
    if (opener.lan) lan = opener.lan;
  }
} catch(error) { }

// Get elements from string
function getelement(text, identifier) {

  identifier = identifier + '=';
  var oleft = text.indexOf(identifier);

  while (oleft != -1 && text.substring(oleft - 1, oleft) != '&' && text.substring(oleft - 1, oleft) != '?') {

    oleft = text.indexOf(identifier, oleft + 1);

  }

  if (oleft != -1) {

    var oright = text.indexOf('&', oleft + 1);
    if (oright == -1) oright = text.length;

    return text.substring(oleft + identifier.length, oright);

  } else {

    return null;

  }

}

// Timestamp formatting
function formattime(time, format) {

  var d = time? new Date(time*1000):new Date();
  var p = d.getHours();
  var q = d.getMinutes();
  var r = d.getSeconds();

  if (p == 24) p = 0;

  var suf = '';
  if (format == 1) {

    if (p < 12) {
      suf = ' am';
    } else {
      p -= 12;
      suf = ' pm';
    }
    if (p == 0) p = 12;

  }

  if (p < 10) p = '0' + p;
  if (q < 10) q = '0' + q;
  if (r < 10) r = '0' + r;

  return time? p+':'+q+suf:p+':'+q+':'+r+suf;

}

// Date formatting
function formatdate(time) {

  var d = new Date(time*1000);
  var p = d.getFullYear();
  var q = d.getMonth() + 1;
  var r = d.getDate();

  if (q < 10) q = '0' + q;
  if (r < 10) r = '0' + r;

  return r+'/'+q+'/'+p;

}

function resizewin(w, h) {

  var curw = document.body.clientWidth || window.innerWidth;
  var curh = document.body.clientHeight || window.innerHeight;

  if (!w) w = curw;
  if (!h) h = curh;

  if (curh != h || curw != w) window.resizeBy(w - curw, h - curh);

}

var actualColor = '';
function setcolor(color) {

  if (!color) {
    if (document.styleSheets) color = document.styleSheets[0].rules? document.styleSheets[0].rules[0].style.backgroundColor:document.styleSheets[0].cssRules[0].style.backgroundColor;
    else color = '#254060';
  }

  document.body.style.backgroundColor = color;
  document.body.style.scrollbarBaseColor = color;
  document.body.style.scrollbarDarkshadowColor = color;
  var arr = document.getElementsByTagName('input');
  for (var i = 0; i < arr.length; i++) { arr[i].style.backgroundColor = color; }

  actualColor = color;

}

function setbackground(color, image) {

  setcolor(color);

  if (image) {

    document.body.style.backgroundImage = 'url('+image+')';

  } else {

    document.body.style.backgroundImage = '';

  }

  if (mainwin && wintype == 'desktop' && parent) {
    parent.setbackground(color, image, 0, 0, 0);
    if (!parent.transparency && parent.document.getElementById('table0')) parent.document.getElementById('table0').style.backgroundColor = actualColor;
  }

}

var popups = new Array();
function openPopup(id) {

  var URL = id;
  if (id == 'help') URL += lan;
  URL += '.html';
  if (mainwin) URL = 'html/' + URL;
  if (arguments.length > 1) URL += '?' + arguments[1];
  var winName = winpfx + id;

  if (!popups[winName] || popups[winName].closed) {

    var height = popupSize[id][0];
    var width = popupSize[id][1];
    var top = parseInt((screen.availHeight - popupSize[id][2]) / 2, 10);
    var left = parseInt((screen.availWidth - popupSize[id][3]) / 2, 10);

    popups[winName] = window.open(URL, winName, 'top='+top+',left='+left+',height='+height+',width='+width+',toolbar=no,menubar=no,scrollbars=yes,resizable=no,location=no,directories=no,status=no');

  }

  popups[winName].focus();

}

function closePopups() {

  for (var winName in popups) {

    if (popups[winName] && !popups[winName].closed) {
        popups[winName].onunload = null;
        popups[winName].close();
    }

  }

  if (!mainwin && opener && opener.popups && opener.popups[window.name]) {
    try { opener.popups[window.name] = null; }
    catch(error) { }
  }

}

// topic object
function Topic(arg) {

  // set default properties
  this.topic = 'x';
  this.title = 'unknown';
  this.forumid = 'ZZZ';
  this.forum = 'x';
  this.stime = 0;
  this.topicstarter = 'unknown';
  this.starterid = 'x';
  this.time = 0;
  this.lastreplier = 'unknown';
  this.replierid = 'x';
  this.numreplies = 0;
  this.ltime = 0;
  this.curreplies = 0;
  this.track = 1;

  // override properties from arguments
  for (var el in arg) { this[el] = arg[el]; }

}

// Topic toSource method
function Topic_toSource() {
  var returnstring = '{';
  for (var el in this) {
    if (!Topic.prototype[el]) {
      if (returnstring.length > 1) returnstring += ',';
      returnstring += el +':';
      if (typeof this[el] == 'string') returnstring += '\'' + this[el] + '\'';
      else returnstring += this[el];
    }
  }
  returnstring += '}';
  return returnstring;
}
Topic.prototype.toSource = Topic_toSource;
